'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const wrap = require('pandora-spawn-wrap');
const MonitorManager_1 = require("../monitor/MonitorManager");
const SpawnWrapperUtils_1 = require("./SpawnWrapperUtils");
const Facade_1 = require("../Facade");
async function main() {
    SpawnWrapperUtils_1.SpawnWrapperUtils.increaseLevel();
    if (!SpawnWrapperUtils_1.SpawnWrapperUtils.decideFollow()) {
        // unwrap it
        if (wrap.lastUnwrap) {
            wrap.lastUnwrap(true);
        }
    }
    if (process.argv[2].endsWith('/npm')) {
        wrap.runMain();
        return;
    }
    try {
        const context = SpawnWrapperUtils_1.SpawnWrapperUtils.shimProcessContext();
        Facade_1.Facade.set('processContext', context.processContextAccessor);
        // Make sure start IPC Hub at very beginning, be course of injectMonitor() needs
        if (!process.env.SKIP_IPC_HUB) {
            const ipcHub = context.getIPCHub();
            await ipcHub.start();
            await ipcHub.initConfigClient();
        }
        MonitorManager_1.MonitorManager.injectProcessMonitor();
        await context.start();
    }
    catch (err) {
        console.error(err);
    }
    wrap.runMain();
}
main().catch(console.error);
//# sourceMappingURL=spawnWrapper.js.map